<$INCLUDE FILE="inc/macro.hsc">
<WEBPAGE chapter="hsc - Features - " title="Absolute URIs">

Let's asume this directory structure for your html-project:

<PRE>
     prj/
     |
     +-image/
     | |
     | +-back.gif
     | |
     | +-logo.gif
     |
     +-people/
     | |
     | +-hugo.html
     | |
     | +-hugo.gif
     | |
     | :
     |
     +-main.html
</PRE>

If e.g. "main.html" wants to refer to "logo.gif", the situation is
quite clear: Insert a

  <BLOCKQUOTE>
  <TG>IMG SRC="image/logo.gif"</TG>
  </BLOCKQUOTE>

in "main.html", and the logo will appear.

But what if "hugo.html" will display the same logo? With
relative URIs (as supported by html), you will have to
insert a

  <BLOCKQUOTE>
  <TG>IMG SRC="../image/logo.gif"</TG>
  </BLOCKQUOTE>

And a file located another directory lever deeper will have to use
<TT>"../../image/logo.gif"</TT> as path. Within big projects, this
becomes very annoying because you always have to know in which
directory level the file you are currently editing is located.
<P>

With absolute URIs, you can always use
  <BLOCKQUOTE>
  <TG>IMG SRC="image/logo.gif"</TG>
  </BLOCKQUOTE>
even from a file called e.g "people/ugly/blond/tall/sepp.html".<P>

This becomes even more useful with macros:
for example, you could write a macro that inserts a button refering
to your main page:
  <BLOCKQUOTE><TT>
  &lt;$MACRO BUTTON_MAIN&gt;<BR>
  &lt;A HREF="main.html"&gt;<BR>
  &lt;IMG SRC="image/main.gif" ALT="Main"&gt;<BR>
  &lt;/A&gt;<BR>
  &lt;/$MACRO&gt;
  </TT></BLOCKQUOTE>

So you can add a button to your mainpage by simply using

  <BLOCKQUOTE><TT>
  &lt;BUTTON_MAIN&gt;<BR>
  </TT></BLOCKQUOTE>

in any file of your project. And, that's the feature,
independent of the location in the directory path of the calling file.<P>

Well, maybe the term "absolut URI" is not really correct. Absolut URIs don't
refer to absolut paths on your local disk. The refer relative to the
main directory of your project. Usually, this is the directory where your
<TT>makefile</TT> is located and therefor <STRONG>hsc</STRONG> is envoked
from. Everything clear now?<P>

Of course, in the destination HTML-file, all absolute URIs are converted
to relativ URIs.<P>

To work with absolut URIs, enable the <A HREF="options.html">AbsUri</A>
switch.<P>

<MAIN>
<PREV href="features/checkuri.html">
<NEXT href="features/macros.html">
</WEBPAGE>

