


XSET(1)                  USER COMMANDS                    XSET(1)



NAME
     xset - user preference utility for X

SYNOPSIS
     xset [-display display] [-b] [b on/off]  [b  [volume  [pitch
     [duration]]]  [[-]bc] [-c] [c on/off] [c [volume]] [[-+]fp[-
     +=] path[,path[,...]]]  [fp  default]  [fp  rehash]  [[-]led
     [integer]]  [led  on/off]  [m[ouse]  [accel_mult[/accel_div]
     [threshold]]] [m[ouse] default] [p pixel color] [[-]r  [key-
     code]] [r on/off] [s [length [period]]] [s blank/noblank] [s
     expose/noexpose] [s on/off]  [s  default]  [s  activate]  [s
     reset] [q]

DESCRIPTION
     This program is used to set various user preference  options
     of the display.

OPTIONS
     -display display
             This option specifies the server to use; see X(1).

     b       The b option controls bell volume, pitch  and  dura-
             tion.   This  option  accepts  up to three numerical
             parameters, a preceding dash(-), or a 'on/off' flag.
             If  no  parameters  are  given,  or the 'on' flag is
             used, the system defaults will be used.  If the dash
             or 'off' are given, the bell will be turned off.  If
             only one numerical  parameter  is  given,  the  bell
             volume will be set to that value, as a percentage of
             its maximum.  Likewise, the second numerical parame-
             ter  specifies  the  bell  pitch,  in hertz, and the
             third numerical parameter specifies the duration  in
             milliseconds.   Note  that not all hardware can vary
             the bell characteristics.  The X server will set the
             characteristics  of the bell as closely as it can to
             the user's specifications.

     bc      The bc option controls bug compatibility mode in the
             server,  if  possible;  a preceding dash(-) disables
             the mode, otherwise the mode  is  enabled.   Various
             pre-R4  clients pass illegal values in some protocol
             requests, and pre-R4 servers did not correctly  gen-
             erate errors in these cases.  Such clients, when run
             against an R4 server, will terminate  abnormally  or
             otherwise  fail  to operate correctly.  Bug compati-
             bility mode  explicitly  reintroduces  certain  bugs
             into  the  X  server,  so that many such clients can
             still be run.  This mode should be used  with  care;
             new application development should be done with this
             mode disabled.  The server  must  support  the  MIT-
             SUNDRY-NONSTANDARD  protocol  extension in order for
             this option to work.



X Version 11         Last change: Release 6                     1






XSET(1)                  USER COMMANDS                    XSET(1)



     c       The c option controls key click.   This  option  can
             take  an  optional value, a preceding dash(-), or an
             'on/off' flag.  If no parameter or the 'on' flag  is
             given, the system defaults will be used. If the dash
             or 'off' flag is used, keyclick  will  be  disabled.
             If  a  value  from  0 to 100 is given, it is used to
             indicate volume, as a  percentage  of  the  maximum.
             The  X  server  will  set  the volume to the nearest
             value that the hardware can support.

     fp= path,...
             The fp= sets the font path to the entries  given  in
             the  path  argument.  The entries are interpreted by
             the server, not by the client.  Typically  they  are
             directory  names  or  font  server  names,  but  the
             interpretation is server-dependent.

     fp default
             The default argument causes  the  font  path  to  be
             reset to the server's default.

     fp rehash
             The rehash argument resets  the  font  path  to  its
             current value, causing the server to reread the font
             databases in the current font path.   This  is  gen-
             erally  only  used  when  adding new fonts to a font
             directory (after running mkfontdir to  recreate  the
             font database).

     -fp or fp-
             The -fp and fp- options  remove  elements  from  the
             current  font  path.   They  must  be  followed by a
             comma-separated list of entries.

     +fp or fp+
             This +fp and fp+ options prepend and append elements
             to  the  current font path, respectively.  They must
             be followed by a comma-separated list of entries.

     led     The led option controls  the  keyboard  LEDs.   This
             controls  the turning on or off of one or all of the
             LEDs.  It accepts an optional integer,  a  preceding
             dash(-) or an 'on/off' flag.  If no parameter or the
             'on' flag is given, all LEDs are turned  on.   If  a
             preceding  dash or the flag 'off' is given, all LEDs
             are turned off.  If a value  between  1  and  32  is
             given,  that  LED will be turned on or off depending
             on the existence of a preceding dash.  A common  LED
             which  can  be  controlled is the ``Caps Lock'' LED.
             ``xset led 3'' would turn led #3  on.   ``xset  -led
             3''  would  turn  it off.  The particular LED values
             may refer to different LEDs on different hardware.



X Version 11         Last change: Release 6                     2






XSET(1)                  USER COMMANDS                    XSET(1)



     m       The m option controls  the  mouse  parameters.   The
             parameters  for  the  mouse  are  `acceleration' and
             `threshold'.  The acceleration can be  specified  as
             an  integer, or as a simple fraction.  The mouse, or
             whatever pointer the machine is connected  to,  will
             go `acceleration' times as fast when it travels more
             than `threshold' pixels in a short time.  This  way,
             the  mouse can be used for precise alignment when it
             is moved slowly, yet it can be set to travel  across
             the  screen  in  a  flick of the wrist when desired.
             One or both parameters for the m option can be omit-
             ted,  but  if  only  one is given, it will be inter-
             preted as the acceleration.  If no parameters or the
             flag  'default' is used, the system defaults will be
             set.

     p       The p  option  controls  pixel  color  values.   The
             parameters   are  the  color  map  entry  number  in
             decimal, and a color specification.  The root  back-
             ground  colors  may  be  changed  on some servers by
             altering the entries for BlackPixel and  WhitePixel.
             Although  these are often 0 and 1, they need not be.
             Also, a server may choose to allocate  those  colors
             privately, in which case an error will be generated.
             The map entry must not be a read-only color,  or  an
             error will result.

     r       The r option controls the autorepeat.  If a  preced-
             ing  dash or the 'off' flag is used, autorepeat will
             be disabled.  If no parameters or the 'on'  flag  is
             used,  autorepeat  will  be  enabled.  If a specific
             keycode is specified as a parameter, autorepeat  for
             that keycode is enabled or disabled.

     s       The s option lets you set the screen  saver  parame-
             ters.   This  option  accepts  up  to  two numerical
             parameters,    a    'blank/noblank'     flag,     an
             'expose/noexpose'   flag,   an   'on/off'  flag,  an
             'activate/reset' flag, or the 'default' flag.  If no
             parameters or the 'default' flag is used, the system
             will be set to its default screen saver characteris-
             tics.   The  'on/off'  flags  simply turn the screen
             saver functions on  or  off.   The  'activate'  flag
             forces activation of screen saver even if the screen
             saver had been turned off.  The 'reset' flag  forces
             deactivation  of  screen saver if it is active.  The
             'blank' flag sets the preference to blank the  video
             (if  the  hardware  can do so) rather than display a
             background pattern, while 'noblank' sets the prefer-
             ence  to  display  a  pattern  rather than blank the
             video.  The 'expose' flag  sets  the  preference  to
             allow   window  exposures  (the  server  can  freely



X Version 11         Last change: Release 6                     3






XSET(1)                  USER COMMANDS                    XSET(1)



             discard window contents), while 'noexpose' sets  the
             preference to disable screen saver unless the server
             can regenerate the screens without causing  exposure
             events.   The  length  and period parameters for the
             screen saver function determines how long the server
             must  be inactive for screen saving to activate, and
             the period to change the background pattern to avoid
             burn  in.   The  arguments are specified in seconds.
             If only one numerical parameter is given, it will be
             used for the length.

     q       The q option gives you information  on  the  current
             settings.

     These settings will be reset to default values when you  log
     out.

     Note that not all X implementations are guaranteed to  honor
     all of these options.

SEE ALSO
     X(1), Xserver(1), xmodmap(1), xrdb(1), xsetroot(1)

AUTHOR
     Bob Scheifler, MIT Laboratory for Computer Science
     David Krikorian, MIT Project Athena (X11 version)





























X Version 11         Last change: Release 6                     4



