


XCLOCK(1)                USER COMMANDS                  XCLOCK(1)



NAME
     xclock - analog / digital clock for X

SYNOPSIS
     xclock [ -help ] [ -analog ] [ -digital ] [ -chime ]  [  -hd
     color  ] [ -hl color ] [ -update seconds ] [ -padding number
     ]

DESCRIPTION
     The xclock program displays the time in  analog  or  digital
     form.  The time is continuously updated at a frequency which
     may be specified by the user.

OPTIONS
     Xclock accepts all of the standard X  Toolkit  command  line
     options along with the additional options listed below:

     -help   This option indicates that a brief  summary  of  the
             allowed  options  should  be printed on the standard
             error.

     -analog This option indicates that a  conventional  12  hour
             clock face with tick marks and hands should be used.
             This is the default.

     -digital or -d
             This option indicates that a 24 hour  digital  clock
             should be used.

     -chime  This option indicates that the  clock  should  chime
             once on the half hour and twice on the hour.

     -hands color (or -hd color)
             This option specifies the color of the hands  on  an
             analog clock.  The default is black.

     -highlight color (or -hl color)
             This option specifies the color of the edges of  the
             hands  on  an  analog  clock,  and is only useful on
             color displays.  The default is black.

     -update seconds
             This option specifies the frequency  in  seconds  at
             which  xclock  should  update  its  display.  If the
             clock is obscured  and  then  exposed,  it  will  be
             updated  immediately.  A value of 30 seconds or less
             will enable a second hand on an analog  clock.   The
             default is 60 seconds.

     -padding number
             This option specifies the width  in  pixels  of  the
             padding  between the window border and clock text or



X Version 11         Last change: Release 6                     1






XCLOCK(1)                USER COMMANDS                  XCLOCK(1)



             picture.  The default is 10 on a digital clock and 8
             on an analog clock.

X DEFAULTS
     This program uses the Clock widget.  It understands  all  of
     the core resource names and classes as well as:

     width (class Width)
             Specifies the width of the clock.  The  default  for
             analog clocks is 164 pixels; the default for digital
             clocks is whatever is needed to hold the clock  when
             displayed in the chosen font.

     height (class Height)
             Specifies the height of the clock.  The default  for
             analog clocks is 164 pixels; the default for digital
             clocks is whatever is needed to hold the clock  when
             displayed in the chosen font.

     update (class Interval)
             Specifies the frequency in seconds at which the time
             should be redisplayed.

     foreground (class Foreground)
             Specifies the color for the tic marks.  The  default
             is depends on whether reverseVideo is specified.  If
             reverseVideo is specified  the  default  is  lwhite,
             otherwise the default is black.


     hands (class Foreground)
             Specifies the color of the insides  of  the  clock's
             hands.  The default is depends on whether reverseVi-
             deo is specified.  If reverseVideo is specified  the
             default is lwhite, otherwise the default is black.

     highlight (class Foreground)
             Specifies the color used to  highlight  the  clock's
             hands. The default is
              depends on whether reverseVideo is  specified.   If
             reverseVideo  is  specified  the  default is lwhite,
             otherwise the default is black.

     analog (class Boolean)
             Specifies whether or not an analog clock  should  be
             used instead of a digital one.  The default is True.

     chime (class Boolean)
             Specifies whether or not a bell should  be  rung  on
             the hour and half hour.

     padding (class Margin)



X Version 11         Last change: Release 6                     2






XCLOCK(1)                USER COMMANDS                  XCLOCK(1)



             Specifies the amount of internal padding  in  pixels
             to be used.  The default is 8.

     font (class Font)
             Specifies the font to be used for the digital clock.
             Note  that  variable  width fonts currently will not
             always display correctly.

WIDGETS
     In order to specify resources, it  is  useful  to  know  the
     hierarchy of the widgets which compose xclock.  In the nota-
     tion below, indentation  indicates  hierarchical  structure.
     The widget class name is given first, followed by the widget
     instance name.

     XClock  xclock
          Clock  clock


ENVIRONMENT
     DISPLAY to get the default host and display number.

     XENVIRONMENT
             to get the name of a resource  file  that  overrides
             the  global resources stored in the RESOURCE_MANAGER
             property.

FILES
     <XRoot>/lib/X11/app-defaults/XClock  -  specifies   required
     resources

SEE ALSO
     X(1), xrdb(1), time(3C)

BUGS
     Xclock believes the system clock.

     When in digital mode, the string should be centered automat-
     ically.

AUTHORS
     Tony Della Fera (MIT-Athena, DEC)
     Dave Mankins (MIT-Athena, BBN)
     Ed Moy (UC Berkeley)











X Version 11         Last change: Release 6                     3



