


XSETROOT(1)              USER COMMANDS                XSETROOT(1)



NAME
     xsetroot - root window parameter setting utility for X

SYNOPSIS
     xsetroot [-help] [-def] [-display display] [-cursor  cursor-
     file  maskfile] [-cursor_name cursorname] [-bitmap filename]
     [-mod x y] [-gray] [-grey] [-fg color] [-bg color] [-rv]  [-
     solid color] [-name string]

DESCRIPTION
     The setroot program allows you to tailor the  appearance  of
     the background ("root") window on a workstation display run-
     ning X.  Normally, you experiment with  xsetroot  until  you
     find  a  personalized  look  that  you  like,  then  put the
     xsetroot command that produces it into your X startup  file.
     If  no  options  are specified, or if -def is specified, the
     window is reset to its default state.  The -def  option  can
     be  specified  along  with  other  options and only the non-
     specified characteristics  will  be  reset  to  the  default
     state.

     Only one of the background color/tiling changing options  (-
     solid,  -gray, -grey, -bitmap, and -mod) may be specified at
     a time.

OPTIONS
     The various options are as follows:

     -help
          Print a usage message and exit.

     -def Reset unspecified attributes  to  the  default  values.
          (Restores  the background to the familiar gray mesh and
          the cursor to the hollow x shape.)

     -cursor cursorfile maskfile
          This lets you change the pointer cursor to whatever you
          want  when the pointer cursor is outside of any window.
          Cursor and mask files are  bitmaps  (little  pictures),
          and  can be made with the bitmap(1) program.  You prob-
          ably want the mask file to be all black until  you  get
          used to the way masks work.

     -cursor_name cursorname
          This lets you change the pointer cursor to one  of  the
          standard cursors from the cursor font.  Refer to appen-
          dix B of the X protocol for the names (except that  the
          XC_ prefix is elided for this option).

     -bitmap filename
          Use the bitmap specified in the file to set the  window
          pattern.   You  can  make your own bitmap files (little



X Version 11         Last change: Release 6                     1






XSETROOT(1)              USER COMMANDS                XSETROOT(1)



          pictures) using  the  bitmap(1)  program.   The  entire
          background  will  be made up of repeated "tiles" of the
          bitmap.

     -mod x y
          This is used if you want a plaid-like grid  pattern  on
          your  screen.   x  and y are integers ranging from 1 to
          16.  Try the different combinations.  Zero and negative
          numbers are taken as 1.

     -gray
          Make the entire background gray.  (Easier on the eyes.)

     -grey
          Make the entire background grey.

     -fg color
          Use ``color'' as the foreground color.  Foreground  and
          background  colors  are  meaningful only in combination
          with -cursor, -bitmap, or -mod.

     -bg color
          Use ``color'' as the background color.

     -rv  This exchanges the foreground  and  background  colors.
          Normally  the  foreground  color is black and the back-
          ground color is white.

     -solid color
          This sets the background of  the  root  window  to  the
          specified  color.   This option is only useful on color
          servers.

     -name string
          Set the name of the root window to  ``string''.   There
          is  no  default value.  Usually a name is assigned to a
          window so that  the  window  manager  can  use  a  text
          representation  when  the  window  is  iconified.  This
          option is unused since  you  can't  iconify  the  back-
          ground.

     -display display
          Specifies the server to connect to; see X(1).

SEE ALSO
     X(1), xset(1), xrdb(1)

AUTHOR
     Mark Lillibridge, MIT Project Athena






X Version 11         Last change: Release 6                     2



